package hu.webarticum.aurora.app.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import hu.webarticum.aurora.app.util.common.IntervalUtil;
import hu.webarticum.aurora.core.model.Block;
import hu.webarticum.aurora.core.model.TimingSet;
import hu.webarticum.aurora.core.model.TimingSet.TimeEntry;
import hu.webarticum.aurora.core.model.time.Interval;

public class TimingSetDisjoiner {

    private final TimingSet timingSet;
    
    
    public TimingSetDisjoiner(TimingSet timingSet) {
        this.timingSet = timingSet;
    }
    

    public TimingSet calculateMaximalDisjointFor(Block block) {
        TimingSet result = new TimingSet();
        if (timingSet.isEmpty()) {
            return result;
        }
        List<Interval> intervals = new ArrayList<Interval>();
        for (TimeEntry entry: timingSet) {
            intervals.add(new Interval(entry.getTime(), block.getLength()));
        }
        intervals = IntervalUtil.getMaximalDisjoint(intervals);
        Iterator<Interval> iterator = intervals.iterator();
        for (TimeEntry entry: timingSet) {
            Interval interval = iterator.next();
            if (entry.getTime().equals(interval.getStart())) {
                result.add(entry);
                if (!iterator.hasNext()) {
                    break;
                }
            }
        }
        return result;
    }
    
}
